<?php defined('SYSPATH') OR die('No direct access allowed.');

class Backup_Controller extends OnlyAps_Controller
{
	public function index()
	{
		$model = new Backup_Model();
		$settings = $model->read();

		$template = new View('templates/default');
		$template->title = 'op5 Config :: Backup';
		$template->content = new View('backup');
		$template->content->transfer = $settings['transfer'];
		$template->content->storagepath = $settings['storagepath'];
		$template->content->server = $settings['server'];
		$template->content->serverpath = $settings['serverpath'];
		$template->content->user = $settings['user'];
		$template->content->password = $settings['password'];
		$template->content->datedirs = $settings['datedirs'];
		$template->content->frequency = $settings['frequency'];
		$template->content->time = $settings['time'];

		expires::set(1);
		$template->render(TRUE);
	}

	public function save()
	{
		$status = false;
		$message = 'The settings have been successfully saved.';

		$transfer = isset($_POST['transfer'])? $_POST['transfer'] : null;
		$storagepath = isset($_POST['storagepath'])? $_POST['storagepath'] : null;
		$server = isset($_POST['server'])? $_POST['server'] : null;
		$serverpath = isset($_POST['serverpath'])? $_POST['serverpath'] : null;
		$user = isset($_POST['user'])? $_POST['user'] : null;
		$password = isset($_POST['password'])? $_POST['password'] : null;
		$datedirs = isset($_POST['datedirs'])? $_POST['datedirs'] : null;
		$frequency = isset($_POST['frequency'])? $_POST['frequency'] : null;
		$time = isset($_POST['time'])? $_POST['time'] : null;

		try
		{
			$model = new Backup_Model();
			$model->edit($transfer, $storagepath, $server, $serverpath, $user, $password, $datedirs, $frequency, $time);
			$status = true;
		}
		catch (Exception $e)
		{
			$message = $e->getMessage();
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}
}
