<?php defined('SYSPATH') OR die('No direct access allowed.');

class Backupnow_Controller extends OnlyAps_Controller
{
	public function index()
	{
		$model = new Backupnow_Model();
		$modules = $model->modules();
		$optional_modules = $model->optional_modules();

		$template = new View('templates/default');
		$template->title = 'op5 Config :: Backup now';
		$template->content = new View('backupnow');
		$template->content->modules = $modules;
		$template->content->optional_modules = $optional_modules;
		expires::set(1);
		$template->render(TRUE);
	}

	public function backup()
	{
		$status = true;
		$settings = op5backup::get_settings();
		$message = 'The backup has been created.';
		if ($settings["transfer"] == "local") {
			if (is_readable($settings['storagepath'])) {
				$message.=' <a href="backupnow/download/?filename='. gethostname() .".". $_REQUEST['filename']
				. '.' . date('Y-m-d') . (($_REQUEST['type'] == 'charch') ? '.charch' : '') . '.backup">Download</a>';
			}
		}

		try
		{
			$model = new Backupnow_Model();
			$backup_modules = (!isset($_REQUEST['backup'])) ? null : $_REQUEST['backup'];
			$model->backup($_REQUEST['type'],  $_REQUEST['filename'], $backup_modules);
		}
		catch (Exception $e)
		{
			$message = $e->getMessage();
			$status = false;
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}

	public function download() {
		$filename = $this->input->get('filename');
		$settings = op5backup::get_settings();

		//$file_path = $this->backups_location . "/" . $filename;
		if ($settings["transfer"] != "local") {
			die("We can't download backup from non-local storage");
		}

		$file_path = rtrim($settings["storagepath"], "/")."/".$filename;

		if (!$filename) {
			die("Missing param: filename");
		}

		if (!is_readable($file_path)) {
			die("Can't read backup-file: $file_path, check path/permissions..");
		}

		if (realpath($file_path) != $file_path) {
			die("No haxx0r today!");
		}

		$fp = fopen($file_path, "r");
		/* Prevent buffering and rendering */
		Kohana::close_buffers(FALSE);
		$this->auto_render = false;
		$hs = headers_sent();

		header('Content-Description: File Transfer');
		header("Content-Type: application/octet-stream");
		header("Content-Disposition: attachment; filename=".$filename);
		header("Content-Transfer-Encoding:binary");
		header('Expires: 0');
		header('Cache-Control: must-revalidate');
		header('Pragma: public');
		header('Content-Length: ' . filesize($file_path));
		fpassthru($fp);
		fclose($fp);
	}

}
