<?php defined('SYSPATH') OR die('No direct access allowed.');

class Email_Controller extends OnlyAps_Controller
{
	public function index()
	{
		$model = new Email_Model();
		$settings = $model->read();

		$template = new View('templates/default');
		$template->title = 'op5 Config :: EMail';
		$template->content = new View('email');
		$template->content->hostname = $settings['hostname'];
		$template->content->relayhost = $settings['relayhost'];
		$template->content->fallback = $settings['fallback'];
		expires::set(1);
		$template->render(TRUE);
	}

	public function save()
	{
		$status = false;
		$message = 'The settings have been successfully saved.';

		$hostname = isset($_POST['hostname'])? $_POST['hostname'] : null;
		$relayhost = isset($_POST['relayhost'])? $_POST['relayhost'] : null;
		$fallback = isset($_POST['fallback'])? $_POST['fallback'] : null;

		try
		{
			$model = new Email_Model();
			$model->edit($hostname, $relayhost, $fallback);
			$status = true;
		}
		catch (Exception $e)
		{
			$message = $e->getMessage();
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}

	public function test()
	{
		$status = false;
		$message = 'The message has been sent.';

		$email = isset($_REQUEST['email'])? $_REQUEST['email'] : null;

		try
		{
			$model = new Email_Model();
			$model->test($email);
			$status = true;
		}
		catch (Exception $e)
		{
			$message = $e->getMessage();
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}
}
