<?php defined('SYSPATH') OR die('No direct access allowed.');

class License_Controller extends Authenticated_Controller
{

	public function __construct()
	{
		parent::__construct();

		$template = new View('templates/default');
		$template->title = 'op5 Config :: License Configuration';
		$template->content = $view = new View('license');

		$view->license_preview = false;
		$error = null;

		$view->license = new op5license();

		if (isset($_POST['action']) && $_POST['action'] == 'upload') {
			if (!isset($_FILES['license_file'], $_FILES['license_file']['tmp_name'], $_FILES['license_file']['name'])) {
				$error = 'No file was uploaded.';
			}
			else {
				$suffix = ".lic";
				if (preg_match("/\.xml$/", $_FILES['license_file']['name'])) {
					$suffix = ".xml";
				}
				$view->tmpname = tempnam("/tmp", "op5license-tmp-") . $suffix;

				try {
					$view->license = new op5license($_FILES['license_file']['tmp_name'] . ".lic");
					if ( @move_uploaded_file($_FILES['license_file']['tmp_name'], $view->tmpname)) {
						$view->license_preview = true;
					} else {
						$error = 'Could not move uploaded file. This should not happen, please try again.';
					}
				} catch (Op5LicenseException $e) {
					$error = $e->get_message();
				}
			}
		} elseif (isset($_POST['action']) && $_POST['action'] == 'install' && isset($_POST['tmp_name'])) {
			if (!is_file($_POST['tmp_name'])) {
				$error = 'Could not find the uploaded file. Aborting.';
			}
			else {
				$suffix = ".lic";
				if (preg_match("/\.xml$/", $_POST['tmp_name'])) {
					$suffix = ".xml";
				}
				if (!@rename($_POST['tmp_name'], "/etc/op5license/op5license" . $suffix)) {
					$error = 'License installation failed!';
				}
			}
		}

		if($error) {
			$view->errors = array($error);
			$template->render(true);
			return;
		}

		if ($view->license_preview) {
			$view->license = new op5license(preg_replace("/\.xml$/", ".lic", $view->tmpname));
		}
		$view->license_metadata = $view->license->get_metadata();

		$template->render(TRUE);
	}

	public function index() {}
}
