<?php defined('SYSPATH') OR die('No direct access allowed.');

class Mngssl_Controller extends OnlyAps_Controller
{
	protected function _get_file_path($name) {
		if (isset($_FILES[$name])) {
			if (isset($_FILES[$name]["tmp_name"])) {
				return strlen($_FILES[$name]["tmp_name"]) ? $_FILES[$name]["tmp_name"] : FALSE;
			}
		}
		return FALSE;
	}

	public function index()
	{
		$template = new View('templates/default');
		$template->title = 'op5 Config :: SSL Management';
		$template->content = new View('mngssl');
		$template->content->result = isset($_GET["result"]) ? $_GET["result"] : NULL;
		if(isset($_SESSION['result']) && $_SESSION['result'] == 'success')
		{
			$template->content->show_confirm = 'yes';
			unset($_SESSION['result']);		
		}
		else
		{
			$template->content->show_confirm = 'no';
		}
		$template->content->message = isset($_GET["msg"]) ? $_GET["msg"] : NULL;
		$template->render(TRUE);
	}

	public function save() {
		$cert_path = $this->_get_file_path("cert");
		$key_path = $this->_get_file_path("key");
		$ca_bundle = $this->_get_file_path("ca-bundle");

		$result = false;
		$message = "";
		try {
			$model = new Mngssl_Model();
			$model->set($cert_path, $key_path, $ca_bundle);
			$result = true;
		} catch(Exception $e) {
			$message = $e->getMessage();
		}
		$message = $result ? "" : ("&msg=".urlencode($message));
		$result = $result ? "success" : "failure";
		$_SESSION['result'] = $result;
		url::redirect("/mngssl?result=$result$message");
	}
	
	public function restart() {
		$model = new Services_Model();
		$model->restart("Apache");
	}
}
