<?php defined('SYSPATH') OR die('No direct access allowed.');

class Network_Controller extends OnlyAps_Controller
{
	public function index()
	{
		$model = new Network_Model();
		$template = new View('templates/default');
		$template->title = 'op5 Config :: Network Settings';
		$template->content = new View('network');
		list($settings, $eths, $bonds) = $model->read();
		$template->content->settings = $settings;
		$template->content->settings_json = Json::encode($settings);
		$template->content->eths = $eths;
		$template->content->eths_json = Json::encode($eths);
		$template->content->bonds = $bonds;
		$template->content->bonds_json = Json::encode($bonds);
		$template->content->server_addr = $_SERVER["SERVER_ADDR"];
		expires::set(1);
		$template->render(TRUE);
	}

	public function save()
	{
		$status = false;
		$message = 'The settings have been successfully saved.';

		$settings = Json::decode_simple($_REQUEST['settings']);
		$eths = Json::decode_simple($_REQUEST['eths']);
		$bonds = Json::decode_simple($_REQUEST['bonds']);

		try
		{
			$model = new Network_Model();
			$model->edit($settings, $eths, $bonds);
			$status = true;
		}
		catch (Exception $e)
		{
			$message = $e->getMessage();
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}
}
