<?php defined('SYSPATH') OR die('No direct access allowed.');

class Password_Controller extends OnlyAps_Controller
{
	public function index()
	{
		$template = new View('templates/default');
		$template->content = new View('password');
		$template->title = 'op5 Config :: Change password';
		expires::set(1);
		$template->render(TRUE);
	}

	public function change()
	{
		$status = false;
		$message = 'The password has been successfully changed.';

		$password = isset($_POST['password'])? $_POST['password'] : null;
		$newpassword = isset($_POST['newpassword'])? $_POST['newpassword'] : null;
		$repassword = isset($_POST['repassword'])? $_POST['repassword'] : null;

		if ($newpassword != $repassword)
			$message = 'Passwords do not match.';
		else
		{
			$password = base64_encode($password);
			$newpassword = base64_encode($newpassword);
			try
			{
				$model = new Password_Model();
				if ($model->verify('root', $password))
				{
					$model->set('root', $newpassword);
					$status = true;
				}
				else
					$message = 'The provided current password is invalid.';
			}
			catch (Exception $e)
			{
				$message = $e->getMessage();
			}
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}
}
