<?php defined('SYSPATH') OR die('No direct access allowed.');

class Services_Controller extends OnlyAps_Controller
{
	public function index()
	{
		$model = new Services_Model();
		$services = $model->read();

		$template = new View('templates/default');
		$template->title = 'op5 Config :: Services';
		$template->content = new View('services');
		$template->content->services = $services;
		expires::set(1);
		$template->render(TRUE);
	}

	public function toggle()
	{
		$status = false;
		try
		{
			$model = new Services_Model();
			switch ($_GET['action'])
			{
				case 'start':
					$message = 'The service has been started.';
					$model->start($_GET['service']);
					break;

				case 'restart':
					$message = 'The service has been restarted.';
					$model->restart($_GET['service']);
					break;

				case 'stop':
					$message = 'The service has been stopped.';
					$model->stop($_GET['service']);
					break;
			}
			$status = true;
		}
		catch (Exception $e)
		{
			$message = $e->getMessage();
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}
}
