<?php defined('SYSPATH') OR die('No direct access allowed.');

class Update_Controller extends OnlyAps_Controller
{
	public function index()
	{
		$model = new Update_Model();

		$template = new View('templates/default');
		$template->title = 'op5 Config :: Update System';
		$template->content = new View('update');
		$template->content->autoupdate = $model->autoupdate();
		if (!file_exists('/var/run/yum.pid'))
			$template->content->packages = $model->packages();
		else
			$template->content->packages = false;
		expires::set(1);
		$template->render(TRUE);
	}

	public function update()
	{
		$status = false;

		try
		{
			$model = new Update_Model();
			if (isset($_POST['save']))
			{
				$message = 'The settings have been successfully saved.';
				$model->edit($_POST['autoupdate']);
			}
			else
			{
				$message = 'The update process has been started.';
				$model->update($_POST['packages']);
			}
			$status = true;
		}
		catch (Exception $e)
		{
			$message = $e->getMessage();
		}

		$reply = array('status' => $status, 'message' => $message);
		expires::set(1);
		print Json::encode($reply);
	}

    public function status()
    {
	$status = false; 
	$message = '';
	
	$start_byte = (int) $_GET['startByte'];
	
	$filename = "/tmp/opt_op5sys_lib_conf_centos_packages_edit_log";
	if(file_exists($filename))
	{
	    if(is_readable($filename)){
	        $message = file_get_contents($filename, NULL, NULL, $start_byte);
		$status = true;
	    }else{
		$message = 'Cannot open file';
	    }
	}
	
	if(strlen($message) == 0){
	    //check if "yum update .." finished
	    $control_filename = '/tmp/opt_op5sys_lib_conf_centos_packages_edit_finished';
	    if(file_exists($control_filename))
	    {
		$status = false;
		//unlink($filename);
		unlink($control_filename);
	    }
	
	}
	
	$reply = array('status' => $status, 'message' => $message);
	print Json::encode($reply);
    }

}
