<?php

class Json
{
	private function is_list(&$array)
	{
		if (!count($array))
			return true; // consider empty arrays as lists

		foreach (array_keys($array) as $key)
			if (is_int($key))
				return true;
	}

	public function encode(&$var)
	{
		switch (gettype($var))
		{
			case 'NULL':
				return 'null';
			case 'boolean':
				return $var ? 'true' : 'false';
			case 'integer':
				return $var;
			case 'double':
				return sprintf('%F', $var);
			case 'string':
				return '"' . str_replace(array("\\", "/", "\n", "\t", "\r", "\b", "\f", '"'),
					array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"'), $var) . '"';
			case 'array':
				$members = array();
				if (self::is_list($var))
				{
					foreach ($var as $value)
						$members[] = self::encode($value);
					return '[' . implode(',', $members) . ']';
				}
				else
				{
					foreach ($var as $key => $value)
						$members[] = self::encode($key) . ':' . self::encode($value);
					return '{' . implode(',', $members) . '}';
				}
			case object:
				return self::encode(get_object_vars($var));
		}
	}

	// this function is not suitable for decoding JSON where strings have {, :, }, [ or ] chars
	public function decode_simple(&$var)
	{
		eval('$settings = ' . str_replace(array('{', ':', '}', '[', ']'),
			array('array(', '=>', ')', 'array(', ')'), $var) . ';');
		return $settings;
	}
}

?>
