<?php defined('SYSPATH') OR die('No direct access allowed.');

class Services_Model
{
	private $services = array(
		'Apache' => 'httpd',
		'Cron' => 'crond',
		'Merlin' => 'merlind',
		'MySQL' => 'mysqld',
		'NRPE' => 'nrpe',
		'NSCA' => 'nsca',
		'NTP' => 'ntpd',
		'Postfix' => 'postfix',
		'PostgreSQL' => 'postgresql',
		'SSH' => 'sshd',
		'Syslog-NG' => 'syslog-ng',
		'loghandler' => 'loghandler',
		'op5 Collector' => 'collector',
		'op5 Monitor' => 'monitor',
		'op5 Processor' => 'processor',
		'smsd' => 'smsd'
	);

	private $config;

	public function __construct()
	{
		$this->config = new Settings();
	}

	public function read()
	{
		$reply = array();
		foreach ($this->services as $name => $service)
			switch ($this->config->read('services', 'status', $service))
			{
				case 'on':
					$reply[$name] = true;
					break;

				case 'off':
					$reply[$name] = false;
					break;
			}

		return $reply;
	}

	public function start($service)
	{
		$this->config->edit('services', 'start', $this->services[$service]);
		$this->config->edit('services', 'toggle', $this->services[$service], 'on');
	}

	public function restart($service)
	{
		$this->config->edit('services', 'restart', $this->services[$service]);
	}

	public function stop($service)
	{
		$this->config->edit('services', 'stop', $this->services[$service]);
		$this->config->edit('services', 'toggle', $this->services[$service], 'off');
	}
}
