<?php defined('SYSPATH') OR die('No direct access allowed.');

class Sms_Model
{
	protected $_config = NULL;

	public function __construct() {
		$this->_config = new Settings();
	}

	public function read()
	{
		$settings = array();
		$res_list = $this->_config->read('sms', 'list');
		if (0 === strlen($res_list)) {
			return $settings;
		}
		$gsms = explode("\n", $res_list);
		foreach($gsms as $gsm) {
			$settings[$gsm]["pincode"] = $this->_config->read('sms', 'setting', "$gsm pin");
			$bcode = $settings[$gsm]["baudrate"] = $this->_config->read('sms', 'setting', "$gsm baudrate");
			$settings[$gsm]["device"] = $this->_config->read('sms', 'setting', "$gsm device");
			if ($bcode == 38400) {;
				$settings[$gsm]["modem"] = 'MC35i';
			} elseif ($bcode == 115200) {
				$settings[$gsm]["modem"] = 'TC65';
			} else {
				$settings[$gsm]["modem"] = 'other';
			}
		}
		return $settings;
	}

	public function edit($pincode, $baudrate)
	{
		$this->_config->edit('sms', 'set', 'GSM1 pin', $pincode);
		$this->_config->edit('sms', 'set', 'GSM1 baudrate', $baudrate);
		$this->_config->apply('sms');
	}

	public function editModem($name, $data) {
		$data["pin"] = $data["pincode"];
		$defaults = array(
			"init" => "ATE0",
			"incoming" => "no",
			"queues" => "OTHER",
			"rtscts" => "no",
			"cs_convert" => "yes",
			"report" => "no",
			"mode" => "new"
		);
		unset($data["pincode"]);
		if ($data["modem"] == "MC35i") {
			$data["baudrate"] = "38400";
		}
		if ($data["modem"] == "TC65") {
			$data["baudrate"] = "115200";
		}
		$data = array_merge($defaults, $data);
		foreach($data as $key => $value) {
			if ($key != "modem") {
				$this->_config->edit('sms', 'set', "$name $key", $value);
			}
		}
		$this->_config->apply('sms');
	}

	public function killall() {
		$this->_config->edit('sms', 'killall', '');
	}

	public function cleanup()
	{
		$this->_config->edit('sms', 'cleanup', '');
	}

	public function test($phone)
	{
		$this->_config->edit('sms', 'test', $phone);
	}
}
