<?php defined('SYSPATH') OR die('No direct access allowed.');

class Time_Model
{
	private $config;

	public function __construct()
	{
		$this->config = new Settings();
	}

	public function servers()
	{
		return explode("\n", $this->config->read('time/ntp', 'servers'));
	}

	public function zones()
	{
		$areas = array('Africa', 'America', 'Asia', 'Australia', 'Europe', 'US', '');
		$zones = array();

		foreach ($areas as $area)
		{
			$zones[$area] = array();
			foreach (explode("\n", $this->config->read('time/zones', 'zones', $area)) as $zone)
				$zones[$area][] = str_replace($area . '/', '', $zone);
			sort($zones[$area]);
		}

		return $zones;
	}

	public function current_zone()
	{
		return $this->config->read('time/zone', 'current');
	}

	public function utc()
	{
		return ($this->config->read('time/utc', 'current') === 'true');
	}

	public function edit($servers, $timezone, $utc)
	{
		$this->config->edit('time/ntp', 'servers', implode(' ', $servers));
		$this->config->apply('time/ntp');
		$this->config->edit('time/zone', 'current', $timezone);
		$this->config->edit('time/utc', 'current', $utc ? 'true' : 'false');
	}
}
