 <?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
var rxHostName = /^(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)*[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/;
var rxPath = /^([-+_~.@!~()\/:0-9A-Za-z]+)$/;
var rxUserName = /^[a-z0-9A-Z_][\@\-\._0-9a-zA-Z]+$/;
var rxTime = /^(2[0-3]|[0-1]?[0-9]):[0-5][0-9]$/;
var goforward = false;

$(document).ready(function(){
	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
	$('#my_form').ajaxForm({
		dataType: 'json',
		beforeSubmit: function(){
			var errors = [];
			if ($('#transfer').val() == 'local')
			{
				if (!rxPath.test($('#storagepath').val()))
					errors.push('#storagepath');
			}
			else
			{
				if (!rxHostName.test($('#server').val()))
					errors.push('#server');

				if (!rxPath.test($('#serverpath').val()))
					errors.push('#serverpath');

				if (!rxUserName.test($('#user').val()))
					errors.push('#user');
			}
			if (errors.length)
			{
				for (i in errors)
					$(errors[i]).addClass('error');
				
				$('#my_form #message td').html('Unacceptable data entered, please specify valid values.');
				$('#my_form #message').attr('class', 'error');
				return false;
			}
			$('#my_form #message td').html('Applying changes...');
			$('#my_form #message').attr('class', 'progress');
			$('#my_form input').blur();
		},
		success: function(response) {
			$('#my_form #message td').text(response.message);
			$('#my_form #message').attr('class', response.status ? 'ok' : 'error');
			if (response.status && goforward)
				setTimeout(function() {
					window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
				}, 1000);
		}
	});
	$('#next').click(function(){
		goforward = true;
	});
	$('#skip').click(function(){
		// why on earth this does not work?
		// $('#left-menu a.selected').parent().next().find('a').trigger('click');
		window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
		return false;
	});
	$('#my_form input, #my_form select').focus(function(){
		$('#my_form #message td').html('&nbsp;');
		$('#my_form #message').removeAttr('class');
		$(this).removeClass('error');
	});
	$('#transfer').change(function(){
		if ($(this).val() == 'ftp' || $(this).val() == 'sftp')
		{
			$('#local').hide();
			$('#tr-server, #tr-path, #tr-user, #tr-password, #tr-datedirs').show();
		}
		else
		{
			$('#tr-server, #tr-path, #tr-user, #tr-password, #tr-datedirs').hide();
			$('#local').show();
		}
	});
});
</script>

<div id="content">
	<form method="post" id="my_form" action="/op5config/backup/save">
		<h1>Backup Settings</h1>
		<p>Configure backup on your system using the built-in backup function. Currently we
		support backup over ftp, sftp or to the directory locally on the server. The backups include
		all data you need to restore crashed op5 system.</p>
		<!--<p><a href="#" class="reset">Reset to factory settings</a></p>-->
		<table summary="Edit backup settings">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('transfer')">[?]</a> <label for="transfer">Storage type</label></td>
				<td>
					<select name="transfer" tabindex="1" id="transfer">
						<option<?php if ($transfer == 'local') echo ' selected="selected"'; ?> value="local">Local</option>
						<option<?php if ($transfer == 'ftp') echo ' selected="selected"'; ?> value="ftp">FTP</option>
						<option<?php if ($transfer == 'sftp') echo ' selected="selected"'; ?> value="sftp">SFTP</option>
					</select>
				</td>
			</tr>
			<!-- local -->
			<tr id="local"<?php if ($transfer != "local") echo ' class="hidden"'; ?>>
				<td><a href="#" onclick="help('storagepath')">[?]</a> <label for="storagepath">Storage path</label></td>
				<td><input type="text" name="storagepath" value="<?php echo $storagepath; ?>" id="storagepath" tabindex="2" class="normal" /></td>
			</tr>
			<!-- /local -->
			<!-- ftp -->
			<tr id="tr-server"<?php if ($transfer != 'ftp' && $transfer != 'sftp') echo ' class="hidden"'; ?>>
				<td><a href="#" onclick="help('server')">[?]</a> <label for="server">Server</label></td>
				<td><input type="text" name="server" value="<?php echo $server; ?>" id="server" tabindex="2" class="normal" /></td>
			</tr>
			<tr id="tr-path"<?php if ($transfer != 'ftp' && $transfer != 'sftp') echo ' class="hidden"'; ?>>
				<td><a href="#" onclick="help('serverpath')">[?]</a> <label for="serverpath">Path</label></td>
				<td><input type="text" name="serverpath" value="<?php echo $serverpath; ?>" id="path" tabindex="3" class="normal" /></td>
			</tr>
			<tr id="tr-user"<?php if ($transfer != 'ftp' && $transfer != 'sftp') echo ' class="hidden"'; ?>>
				<td><a href="#" onclick="help('ftp_user')">[?]</a> <label for="user">User</label></td>
				<td><input type="text" name="user" value="<?php echo $user; ?>" id="user" tabindex="4" class="normal" /></td>
			</tr>
			<tr id="tr-password"<?php if ($transfer != 'ftp' && $transfer != 'sftp') echo ' class="hidden"'; ?>>
				<td><a href="#" onclick="help('ftp_pass')">[?]</a> <label for="password">Password</label></td>
				<td><input type="password" name="password" value="<?php echo $password; ?>" id="pass" tabindex="5" class="normal" /></td>
			</tr>
			<tr id="tr-datedirs"<?php if ($transfer != 'ftp' && $transfer != 'sftp') echo ' class="hidden"'; ?>>
				<td><a href="#" onclick="help('datedirs')">[?]</a> <label for="datedirs">Create date directories</label></td>
				<td><input type="checkbox" name="datedirs" id="datedirs" tabindex="5"<?php if ($datedirs != "no") echo ' checked="checked"'; ?> value="yes" /></td>
			</tr>
			<!--  /ftp -->
			<tr>
				<td><a href="#" onclick="help('frequency')">[?]</a> <label for="frequency">Backup frequency</label></td>
				<td>
					<?php echo form::dropdown('frequency', array('never' => 'Never', 'daily' => 'Daily',
						'weekly' => 'Weekly', 'monthly' => 'Monthly', 'yearly' => 'Yearly'),
						$frequency, 'tabindex="6"'); ?>
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('backup_time')">[?]</a> <label for="backup">Time to backup</label></td>
				<td><input type="text" name="time" value="<?php echo $time; ?>" id="backup" tabindex="7" class="normal" maxlength="5" /> <small>HH:MM</small></td>
			</tr>
			<tr class="dotted-top">
				<td>&nbsp;</td>
				<td><input type="submit" value="Apply" tabindex="8" />
					<input type="submit" id="next" value="Apply &amp; continue" class="grey" tabindex="9" />
					<input type="reset" id="skip" value="Skip &amp; continue" class="grey" tabindex="10" />
				</td>
			</tr>
		</table>
	</form>
</div>

