<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
var rxFileName = /^([-_~.@!~():0-9A-Za-z]+)$/;

$(document).ready(function(){
	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
	$('#my_form').ajaxForm({
		dataType: 'json',
		beforeSubmit: function(){
			if (!rxFileName.test($('#filename').val()))
			{
				$('#filename').addClass('error');
				$('#message td').html('Unacceptable data entered, please specify valid values.');
				$('#message').attr('class', 'error');
				return false;
			}

			$('#message td').html('Creating backup...');
			$('#message').attr('class', 'progress');
			$('#my_form input, #my_form select').blur();
		},
		success: function(response){
			$('#message td').html(response.message);
			$('#message').attr('class', response.status ? 'ok' : 'error');
		}
	});
	$('#type').change(function(){
		if ($(this).val() == 'charch')
			$('#charch').text('.charch');
		else
			$('#charch').text('');
	});
	$('#my_form input, #my_form select').focus(function(){
		$('#message td').html('&nbsp;');
		$('#message').removeAttr('class');
		$(this).removeClass('error');
	});
});
</script>
<form method="post" id="my_form" action="/op5config/backupnow/backup">
	<div id="content">
		<h1>Backup now</h1>
		<p>Backup the system with the selected options.</a></p>
		<table summary="Select backup options">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('backup_type')">[?]</a> <label for="type">Type</label></td>
				<td>
					<select name="type" tabindex="1" id="type">
						<option value="default">default</option>
						<option value="charch">change arch</option>
					</select>
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('backup_modules')">[?]</a> <label for="backup">Backup</label></td>
				<td>
					<?php
					foreach ($modules as $module)
						echo form::checkbox('backup[]', $module, true, 'id="' . $module . '"') . ' '
							. form::label($module, $module) . '<br />';

					foreach ($optional_modules as $module)
						echo form::checkbox('backup[]', $module, false, 'id="' . $module . '"') . ' '
							. form::label($module, $module) . '<br />';
					?>
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('backup_filename')">[?]</a> <label for="filename">Filename</label></td>
				<td><input type="text" name="filename" value="" id="filename" class="normal" />.<?php echo date('Y-m-d'); ?><span id="charch"></span>.backup</td>
			</tr>
			<tr class="dotted-top">
				<td>&nbsp;</td>
				<td><input type="submit" value="Backup" /></td>
			</tr>
		</table>
	</div>
</form>
