<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
var rxHostName = /^(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)*[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/;
var rxEmail = /^[a-z0-9!#$%&'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+(?:[a-z]{2}|com|org|net|gov|mil|biz|info|mobi|name|aero|jobs|museum)$/;
var goforward = false;

$(document).ready(function(){
	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
	$('#my_form').ajaxForm({
		dataType: 'json',
		beforeSubmit: function(){
			var errors = [];

			if ($('#host').val() != '' && !rxHostName.test($('#host').val()))
				errors.push('#host');

			if ($('#relay').val() != '' && !rxHostName.test($('#relay').val()))
				errors.push('#relay');

			if ($('#fallback').val() != '' && !rxHostName.test($('#fallback').val()))
				errors.push('#fallback');

			if (errors.length)
			{
				for (i in errors)
					$(errors[i]).addClass('error');
				
				$('#message td').html('Unacceptable data entered, please specify valid values.');
				$('#message').attr('class', 'error');
				return false;
			}

			$('#message td').html('Applying changes...');
			$('#message').attr('class', 'progress');
			$('#my_form input').blur();
		},
		success: function(response){
			$('#message td').text(response.message);
			$('#message').attr('class', response.status ? 'ok' : 'error');
			if (response.status && goforward)
				setTimeout(function(){
					window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
				}, 1000);
		}
	});
	$('#next').click(function(){
		goforward = true;
	});
	$('#skip').click(function(){
		// why on earth this does not work?
		// $('#left-menu a.selected').parent().next().find('a').trigger('click');
		window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
		return false;
	});
	$('#test').click(function(){
		if (!rxEmail.test($('#email').val()))
		{
			$('#email').addClass('error');			
			$('#message td').html('Unacceptable data entered, please enter valid values.');
			$('#message').attr('class', 'error');
			return false;
		}

		$.getJSON('/op5config/email/test', {"email":$('#email').val()},
			function(data, textStatus)
		{
			$('#message td').text(data.message);
			$('#message').attr('class', data.status ? 'ok' : 'error');
		});
		return false;
	});
	$('#my_form input').focus(function(){
		$('#message td').html('&nbsp;');
		$('#message').removeAttr('class');
		$(this).removeClass('error');
	});
});
</script>
<form method="post" id="my_form" action="/op5config/email/save">
	<div id="content">
		<h1>Email Settings</h1>
		<p>This configures postfix which is the MTA (Mail Transfer Agent) that comes with
		op5 System. The MTA is used primarily to send out notification and report emails from
		op5 software.</p>
		<p><strong>Note:</strong> If you want the MTA to use a relay host (ie forward all emails
		to a specific mail server) edit Relay host and Fallback relay.</p>

		<table summary="Edit email settings">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('hostname')">[?]</a> <label for="host">Host name</label></td>
				<td><input type="text" name="hostname" value="<?php echo $hostname; ?>" id="host" tabindex="1" class="normal" /> <small>optional</small></td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('relayhost')">[?]</a> <label for="relay">Relay host</label></td>
				<td><input type="text" name="relayhost" value="<?php echo $relayhost; ?>" id="relay" tabindex="2" class="normal" /> <small>optional</small></td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('fallback')">[?]</a> <label for="fallback">Fallback relay</label></td>
				<td><input type="text" name="fallback" value="<?php echo $fallback; ?>" id="fallback" tabindex="3" class="normal" /> <small>optional</small></td>
			</tr>
			<tr class="button dotted-top">
				<td>&nbsp;</td>
				<td><input type="submit" value="Apply" tabindex="4" />
				<input type="submit" id="next" value="Apply &amp; continue" class="grey" tabindex="5" />
					<input type="reset" id="skip" value="Skip &amp; continue" class="grey" tabindex="6" /></td>
			</tr>
			<tr class="button dotted-top">
				<td><a href="#" onclick="help('test_email')">[?]</a> <label for="email">Email address</label></td>
				<td><input type="text" name="email" value="" id="email" class="normal" tabindex="7" /> <input type="submit" name="test" value="Send test message" id="test" tabindex="8" /></td>
			</tr>
		</table>
	</div>
</form>
