<?php defined('SYSPATH') OR die('No direct access allowed.');

function print_metadata($array, $depth = 0) {
	echo "<ul>";
	foreach ($array as $key => $val) {
		$key = ($depth === 0) ? ucfirst(preg_replace("/\_/", " ", $key)) : $key;
		if (is_array($val)) {
			if (count($val) >= 1) {
				echo "<li>";
				echo $key . ': ' . print_metadata($val, $depth+1);
				echo "</li>";
			}
		} else {
			echo "<li>";
			echo $key . ': ' . $val;
			echo "</li>";
		}
	}
	echo "</ul>";
}

?>

<script type="text/javascript">
$(function() {
	helper.helptexts["upload_license"] = "You should have received a license file from op5. If you dont have a license file, please contact op5 support.";
});
</script>
<div id="content">
	<?php if ($license_preview): ?>
	<h1>Preview your license information before installing</h1>
	<p>Below you will find a preview of the license file you are trying to install. Please
	review the license file information. If there are no errors and your license information
	appears correct, go to the section "Install license" at the bottom of this page and click
	the <q>Install</q> button.</p>
	<p>If there are any problems with your license file, please contact op5 Support.</p>
	<?php endif; ?>

	<?php if (!empty($errors)): ?>
		<h1>License error</h1>
		<p><strong>The following problems were encountered when loading your license file:</strong></p>
		<ul><?php
			foreach ($errors as $message)
				echo "<li>{$message}</li>";
		?></ul>
		<p>If you have purchased op5 products but have not received a license file, or if
		there are any problems with your installed license file, please contact op5 Support.</p>
		<p>If you need to purchase a new license or upgrade an existing one, please contact
		op5 Sales.<br />
		Purchasing a license will give you the following benefits:</p><ul>
			<li>Professional support, email, telephone and access to support portal</li>
			<li>Automatic updates of new releases</li>
			<li>Access to customized development</li>
			<li>Professional training</li>
			<li>and much more</li>
		</ul>
		<form action="<?php echo 'https://www.op5.com/software-license'; ?>" method="get">
			<p>
				<input type="submit" value="Buy now" />
			</p>
		</form>
	<?php else:
		?>
		<h1>About your op5 Software license</h1>
	<?php
		print_metadata($license_metadata);
	endif;

	if ($license_preview): ?>
	<h1>Install license</h1>
	<p>If the license information above looks correct, press the <q>Install</q> button below to
	install your new license file.</p>
	<form action="/op5config/license" method="post">
		<div>
			<input type="hidden" name="tmp_name" value="<?php echo $tmpname; ?>" />
			<input type="hidden" name="action" value="install" />
			<input type="submit" name="install" value="Install" />
		</div>
	</form>
	<?php else: ?>
	<h1>Install new license</h1>
	<p>Install a new license or replace your existing license. Upload your license file using the form below.</p>
	<form action="/op5config/license" method="post" enctype="multipart/form-data">
		<table summary="Upload license">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr>
				<td><a href="#" onclick="help('upload_license')">[?]</a> <label for="upload_license">Upload license file</label></td>
				<td>
					<input type="hidden" name="MAX_FILE_SIZE" value="100000" />
					<input type="file" name="license_file" id="upload_license" value="" size="44" />
				</td>
			</tr>
			<tr class="button dotted-top">
				<td>&nbsp;</td>
				<td>
					<input type="hidden" name="action" value="upload" />
					<input type="submit" value="Upload" />
				</td>
			</tr>
		</table>
	</form>
	<?php endif; ?>
</div>
