<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
var dnsform = '';
var ethform = '';
var dhcpform = '';
var bondform = '';
var settings = <?php echo $settings_json; ?>;
var eths = <?php echo $eths_json; ?>;
var bonds = <?php echo $bonds_json; ?>;
var rxHostName = /^(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)*[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/;
var rxIPv4Address = /^([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])$/;
var serverAddr = "<?php print $server_addr; ?>";

function json2html(type, iface)
{
	switch (type)
	{
		case 'dns':
			return 'Host name: ' + settings['DNS']['host']
				+ '<br />Primary DNS: '	+ settings['DNS']['dns1']
				+ '<br />Secondary DNS: ' + settings['DNS']['dns2']
				+ '<br />Tertiary DNS: ' + settings['DNS']['dns3'];

		case 'eth':
			return 'IP address: ' + settings[iface]['ip']
				+ '<br />Network mask: ' + settings[iface]['netmask']
				+ '<br />Gateway: ' + settings[iface]['gateway'];

		case 'dhcp':
			return 'Uses DHCP';

		case 'bond':
			return 'Bonded to ' + settings[iface]['bond'];
	}
}

function open_form(cell, type)
{
	if ($('table.form').length)
	{
		if (confirm('You did not finish editing. Do you want to continue?'))
			close_form();
		else
			return;
	}

	var iface = cell.siblings().eq(0).children('label').text();

	close_form(); // make sure another opened form is closed
	cell.siblings('.action').hide();
	cell.attr('colspan', 4); // does not work in IE

	switch (type)
	{
		case 'dns':
			cell.html(dnsform);
			$('#host').val(settings['DNS']['host']);
			$('#dns1').val(settings['DNS']['dns1']);
			$('#dns2').val(settings['DNS']['dns2']);
			$('#dns3').val(settings['DNS']['dns3']);
			break;

		case 'eth':
			cell.html(ethform);
			$('#ip').val(settings[iface]['ip']);
			$('#netmask').val(settings[iface]['netmask']);
			$('#gateway').val(settings[iface]['gateway']);
			break;

		case 'dhcp':
			cell.html(dhcpform);
			break;

		case 'bond':
			cell.html(bondform);
			for (var i in bonds)
				$('#bond').append('<option value="' + bonds[i] + '">' + bonds[i] + '</option>');
			$('#bond').val(settings[iface]['bond']);
			break;
	}
}

function close_form()
{
	if (!$('table.form').length)
		return false;

	var cell = $('table.form').parent();
	cell.removeAttr('colspan');
	cell.html(json2html(cell.attr('class'), cell.siblings().eq(0).children('label').text()));
	cell.siblings('.action').show();
	return false;
}

function update_actions(row)
{
	if (row.hasClass('dns'))
		//row.children().eq(2).html('<a href="#" class="dns">Static</a>');
		row.children().eq(2).html('<a href="#" class="dns">Edit</a>');
	else
		row.children().eq(2).html('<a href="#" class="eth">Static</a>');

	if (!row.hasClass('dns'))
		row.children().eq(3).html('<a href="#" class="dhcp">DHCP</a>');
	else
		row.children().eq(3).html('&nbsp;');

	if (row.hasClass('eth') && bonds.length)
		row.children().eq(4).html('<a href="#" class="bond">Bond</a>');
	else if (row.hasClass('bond'))
		row.children().eq(4).html('<a href="#" class="remove">Remove</a>');
	else
		row.children().eq(4).html('&nbsp;');
}

function update_actions_all()
{
	for (var i in settings)
	{
		var cell = $('#' + i).children().eq(1);
		cell.html(json2html(cell.attr('class'), cell.siblings().eq(0).children('label').text()));
		update_actions($('#' + i));
	}
}

var ip_reg = /(\d)+.(\d)+.(\d)+.(\d)+/;

function get_static_ip_list(call_back) {
	var a = [];
	$("#content table").find("tr.eth, tr.bond").each(function() {
		var res = $(this).find("td").eq(1).text().match(ip_reg);
		if (res) { a.push(res[0]); }
	});
	return a;
}

$(document).ready(function(){
	// store HTML of the rolldown forms into a string for later use
	dnsform = $('#dnsform').html();
	ethform = $('#ethform').html();
	dhcpform = $('#dhcpform').html();
	bondform = $('#bondform').html();

	// remove the rolldown forms from DOM to avoid duplicate ids when creating their instances later
	$('#dnsform').remove();
	$('#ethform').remove();
	$('#dhcpform').remove();
	$('#bondform').remove();

	update_actions_all();

	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);

	$('#save').click(function(){
		var good_bonds = [];
		for (var i in eths)
			if ('bond' in settings[eths[i]] && jQuery.inArray(settings[eths[i]]['bond'], bonds) != -1)
				good_bonds.push(settings[eths[i]]['bond']);
		for (var j in bonds)
			if (jQuery.inArray(bonds[j], good_bonds) == -1)
			{
				alert(bonds[j] + ' has no slave interfaces');
				return false;
			}
		$('#message td').html('Applying changes...');
		$('#message').attr('class', 'progress');
		$.getJSON('/op5config/network/save', {'settings': $.toJSON(settings),
			'eths': $.toJSON(eths), 'bonds': $.toJSON(bonds)}, function(data, textStatus)
		{
			$('#message td').text(data.message);
			$('#message').attr('class', data.status ? 'ok' : 'error');
		});
		setTimeout(function() {
			$.unblockUI();
		}, 5000);
		var ip_list = get_static_ip_list();
		if (!ip_list.length) {
			$('.new-ip-addresses').show().find("td").text("You can access config via addresses provided by DHCP server.");
			return false;
		}

		if($.inArray(serverAddr, ip_list) === -1)  {
			var str = "";
			$.each(ip_list, function() {
				str += "<a href=\"https://"+this+"/op5config/\">"+this+"</a>&nbsp;"
			});
			$('.new-ip-addresses').show().find("td").html("Your network configuration will be change. You can access config GUI via these links: "+str);
			return false;
		}
		return false;
	});
	$('#my_form').mousedown(function(){
		$('#message td').html('&nbsp;');
		$('#message').removeAttr('class');
	});
	$('input').focus(function(){
		$(this).removeClass('error');
	});
	$('#my_form tr td:nth-child(2)').live('dblclick', function(){
		open_form($(this), $(this).attr('class'));
		return false;
	});
	$('#my_form a.dns').live('click', function(){
		open_form($(this).closest('tr').children().eq(1), 'dns');
		return false;
	});
	$('#my_form a.eth').live('click', function(){
		open_form($(this).closest('tr').children().eq(1), 'eth');
		return false;
	});
	$('#my_form a.dhcp').live('click', function(){
		open_form($(this).closest('tr').children().eq(1), 'dhcp');
		return false;
	});
	$('#my_form a.bond').live('click', function(){
		open_form($(this).closest('tr').children().eq(1), 'bond');
		return false;
	});
	$('#my_form a.remove').live('click', function(){
		var iface = $(this).closest('tr').children().eq(0).children('label').text();
		if (confirm('Remove the ' + iface + ' interface?'))
		{
			bonds.splice($.inArray(iface, bonds), 1); // we assume iface exists in bonds
			delete settings[iface];
			for (var i in settings)
				if (settings[i]['bond'] == iface)
				{
					settings[i]['type'] = 'dhcp';
					$('#' + i).children().eq(1).html(json2html('dhcp', i));
					$('#' + i).children().eq(1).attr('class', 'dhcp');
					update_actions($('#' + i));
				}
				else if (!bonds.length)
					update_actions($('#' + i));
			$(this).closest('tr').remove();
		}
		return false;
	});
	$('#my_form a.create').live('click', function(){
		var iface = 'bond' + bonds.length;
		$('#my_form table tr').eq($('#my_form table tr').length - 2).before('<tr id="' + iface + '" class="dotted-top bond">'
			+ '<td><a href="#" onclick="help(\'bond\')">[?]</a> <label for="eth">' + iface + '</label></td>'
			+ '<td class="dhcp">Uses DHCP</td><td class="action"></td><td class="action"></td>'
			+ '<td class="action"></td><td class="action"></td><td class="action"></td></tr>');
		settings[iface] = {"type" : "dhcp"};
		bonds.push(iface);
		if (bonds.length == 1)
			update_actions_all();
		else
			update_actions($('#' + iface));
		return false;
	});
	$('#apply-dns').live('click', function(){
		var errors = [];

		if (!rxHostName.test($('#host').val()))
			errors.push('#host');

		if (!rxIPv4Address.test($('#dns1').val()))
			errors.push('#dns1');

		if ($('#dns2').val() != '' && !rxIPv4Address.test($('#dns2').val()))
			errors.push('#dns2');

		if ($('#dns3').val() != '' && !rxIPv4Address.test($('#dns3').val()))
			errors.push('#dns2');

		if (errors.length)
		{
			for (i in errors)
				$(errors[i]).addClass('error');

			$('#message td').html('Unacceptable data entered, please specify valid values.');
			$('#message').attr('class', 'error');
			return false;
		}

		settings['DNS']['host'] = $('#host').val();
		settings['DNS']['dns1'] = $('#dns1').val();
		settings['DNS']['dns2'] = $('#dns2').val();
		settings['DNS']['dns3'] = $('#dns3').val();
		settings['DNS']['type'] = 'dns';
		var cell = $('table.form').parent();
		cell.attr('class', 'dns');
		update_actions(cell.closest('tr'));
		close_form();
		return false;
	});
	$('#apply-eth').live('click', function(){
		var errors = [];

		if (!rxIPv4Address.test($('#ip').val()))
			errors.push('#ip');

		if (!rxIPv4Address.test($('#netmask').val()))
			errors.push('#netmask');

		if ($('#gateway').val() != "" && !rxIPv4Address.test($('#gateway').val()))
			errors.push('#gateway');

		if (errors.length)
		{
			for (i in errors)
				$(errors[i]).addClass('error');

			$('#message td').html('Unacceptable data entered, please specify valid values.');
			$('#message').attr('class', 'error');
			return false;
		}

		var iface = $('table.form').closest('tr').children().eq(0).children('label').text();
		settings[iface]['ip'] = $('#ip').val();
		settings[iface]['netmask'] = $('#netmask').val();
		settings[iface]['gateway'] = $('#gateway').val();
		settings[iface]['type'] = 'eth';
		var cell = $('table.form').parent();
		cell.attr('class', 'eth');
		update_actions(cell.closest('tr'));
		close_form();
		return false;
	});
	$('#apply-dhcp').live('click', function(){
		var iface = $('table.form').closest('tr').children().eq(0).children('label').text();
		settings[iface]['type'] = 'dhcp';
		var cell = $('table.form').parent();
		cell.attr('class', 'dhcp');
		update_actions(cell.closest('tr'));
		close_form();
		return false;
	});
	$('#apply-bond').live('click', function(){
		; // validate the settings here
		var iface = $('table.form').closest('tr').children().eq(0).children('label').text();
		settings[iface]['bond'] = $('#bond').val();
		settings[iface]['type'] = 'bond';
		var cell = $('table.form').parent();
		cell.attr('class', 'bond');
		update_actions(cell.closest('tr'));
		close_form();
		return false;
	});
	$('.cancel').live('click', function(){
		close_form();
		return false;
	});
});
</script>
<!-- this is a trick to avoid the need to enter all HTML as JS string -->
<div id="dnsform" class="hidden">
	<table class="form">
		<tr>
			<td><a href="#" onclick="help('hostname')">[?]</a> <label for="host">Host name</label></td>
			<td><input type="text" name="hostname" value="" id="host" tabindex="1" class="normal" /></td>
		</tr>
		<tr>
			<td><a href="#" onclick="help('dns')">[?]</a> <label for="dns1">Primary DNS</label></td>
			<td><input type="text" name="dns[]" value="" id="dns1" tabindex="2" class="normal" /></td>
		</tr>
		<tr>
			<td><a href="#" onclick="help('dns')">[?]</a> <label for="dns2">Secondary DNS</label></td>
			<td><input type="text" name="dns[]" value="" id="dns2" tabindex="3" class="normal" /> <small>optional</small></td>
		</tr>
		<tr>
			<td><a href="#" onclick="help('dns')">[?]</a> <label for="dns2">Tertiary DNS</label></td>
			<td><input type="text" name="dns[]" value="" id="dns3" tabindex="4" class="normal" /> <small>optional</small></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<input type="submit" id="apply-dns" name="apply" value="Apply" tabindex="5" />
				<input type="reset" class="cancel" name="cancel" value="Cancel" tabindex="6" />
			</td>
		</tr>
	</table>
</div>
<div id="ethform" class="hidden">
	<table class="form">
		<tr>
			<td><a href="#" onclick="help('ip')">[?]</a> <label for="ip">IP address</label><br /></td>
			<td><input type="text" name="ip" value="" id="ip" tabindex="1" class="normal" /></td>
		</tr>
		<tr>
			<td><a href="#" onclick="help('netmask')">[?]</a> <label for="netmask">Netmask</label></td>
			<td><input type="text" name="netmask" value="" id="netmask" tabindex="2" class="normal" /></td>
		</tr>
		<tr>
			<td><a href="#" onclick="help('gateway')">[?]</a> <label for="gateway">Gateway</label></td>
			<td><input type="text" name="gateway" value="" id="gateway" tabindex="3" class="normal" />
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<input type="submit" id="apply-eth" name="apply" value="Apply" tabindex="4" />
				<input type="reset" class="cancel" name="cancel" value="Cancel" tabindex="5" />
			</td>
		</tr>
	</table>
</div>
<div id="dhcpform" class="hidden">
	<table class="form">
		<tr>
			<td>
			<a href="#" onclick="help('dhcp')">[?]</a> <label>Use DHCP</label></td>
		</tr>
		<tr>
			<td>
				<input type="submit" id="apply-dhcp" name="apply" value="Apply" tabindex="1" />
				<input type="reset" class="cancel" name="cancel" value="Cancel" tabindex="2" />
			</td>
		</tr>
	</table>
</div>
<div id="bondform" class="hidden">
	<table class="form">
		<tr>
			<td><a href="#" onclick="help('master')">[?]</a> <label for="bond">Bond to</label></td>
			<td><select id="bond" name="bond" tabindex="1"></select></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td>
				<input type="submit" id="apply-bond" name="apply" value="Apply" tabindex="2" />
				<input type="reset" class="cancel" name="cancel" value="Cancel" tabindex="3" />
			</td>
		</tr>
	</table>
</div>
<!-- -->
<form method="post" id="my_form" action="/op5config/network/save">
	<div id="content">
		<h1>Network Settings</h1>
		<p>Configure the system's network settings.</p>
		<table summary="Edit Network settings">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
				<col class="auto" />
				<col class="auto" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="5">&nbsp;</td>
			</tr>
			<tr class="new-ip-addresses dotted-bottom" style="display: none">
				<td colspan="5"></td>
			</tr>
			<tr id="DNS" class="dotted-bottom dns">
				<td><a href="#" onclick="help('dns')">[?]</a> <label for="dns">DNS</label></td>
				<td class="<?php echo $settings['DNS']['type']; ?>">&nbsp;</td>
				<td class="action">&nbsp;</td>
				<td class="action">&nbsp;</td>
				<td class="action">&nbsp;</td>
			</tr>
			<?php foreach ($eths as $eth): ?>
			<tr id="<?php echo $eth; ?>" class="dotted-top eth">
				<td><a href="#" onclick="help('eth')">[?]</a> <label for="eth"><?php echo $eth; ?></label></td>
				<td class="<?php echo $settings[$eth]['type']; ?>">&nbsp;</td>
				<td class="action">&nbsp;</td>
				<td class="action">&nbsp;</td>
				<td class="action">&nbsp;</td>
			</tr>
			<?php endforeach; ?>
			<?php foreach ($bonds as $bond): ?>
			<tr id="<?php echo $bond; ?>" class="dotted-top bond">
				<td><a href="#" onclick="help('bond')">[?]</a> <label for="bond"><?php echo $bond; ?></label></td>
				<td class="<?php echo $settings[$bond]['type']; ?>">&nbsp;</td>
				<td class="action">&nbsp;</td>
				<td class="action">&nbsp;</td>
				<td class="action">&nbsp;</td>
			</tr>
			<?php endforeach; ?>
			<tr class="button dotted-top">
				<td>&nbsp;</td>
				<td>&nbsp;</td>
				<td colspan="3"><a href="#" class="create">Create a new bond interface</a></td>
			</tr>
			<tr class="button dotted-top">
				<td>&nbsp;</td>
				<td><input type="submit" id="save" value="Apply" /></td>
				<td colspan="3">&nbsp;</td>
			</tr>
		</table>
	</div>
</form>