<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
$(document).ready(function(){
	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
	$('#my_form').ajaxForm({
		dataType: 'json',
		beforeSubmit: function(){
			var errors = [];
			if (!$('#password').val() || $('#password').val().length < 6)
				errors.push('#password');
			else if (!$('#new_password').val() || $('#new_password').val().length < 6)
				errors.push('#new_password');
			else if (!$('#re_password').val() || $('#re_password').val().length < 6)
				errors.push('#re_password');
			else if ($('#new_password').val() != $('#re_password').val())
			{
				errors.push('#new_password');
				errors.push('#re_password');
			}
			else
			{
				$('#message td').html('Applying changes...');
				$('#message').attr('class', 'progress');
				$('#my_form input').blur();
				return true;
			}

			if (errors.length)
			{
				for (i in errors)
					$(errors[i]).addClass('error');
				
				$('#message td').html('Unacceptable data entered, please specify valid values.');
				$('#message').attr('class', 'error');
				return false;
			}
		},
		success: function(response){
			$('#my_form input[type="password"]').val('');
			$('#message td').text(response.message);
			$('#message').attr('class', response.status ? 'ok' : 'error');
		}
	});
	$('#my_form input').focus(function(){
		$('#message td').html('&nbsp;');
		$('#message').removeAttr('class');
		$(this).removeClass('error');
	});
});
</script>
<form method="post" id="my_form" action="/op5config/password/change">
	<div id="content">
		<h1>Change password</h1>
		<p>Change your root password here. Please remember to create a safe password as this
		is sensitive information. A minimum of 6 characters is required.</p>
		<!--<p><a href="#" class="reset">Reset to factory settings</a></p>-->
		<table summary="Edit root password">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('current_password')">[?]</a> <label for="pin">Current Password</label></td>
				<td>
					<input type="password" name="password" value="" id="password" tabindex="1" class="normal" />
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('new_password')">[?]</a> <label for="pin">New Password</label></td>
				<td>
					<input type="password" name="newpassword" value="" id="new_password" tabindex="2" class="normal" />
					<small>6 characters minimum</small>
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('new_password')">[?]</a> <label for="pin">Repeat password</label></td>
				<td><input type="password" name="repassword" value="" id="re_password" tabindex="3" class="normal" /></td>
			</tr>
			<tr class="dotted-top">
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="do" value="Save" tabindex="4" />
				</td>
			</tr>
		</table>
	</div>
</form>
