<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
var rxHostName = /^(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)*[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/;
var rxPath = /^([-+_~.@!~()\/:0-9A-Za-z]+)$/;
var rxUserName = /^[a-z][_0-9a-z]+$/;
var rxTime = /^(2[0-3]|[0-1]?[0-9]):[0-5][0-9]$/;
var goforward = false;

$(document).ready(function(){
	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
	$('#restore-backup-form').ajaxForm({
		dataType: 'json',
		beforeSubmit: function() {
			var errors = [];

			if ($("#restore-file-path").val() == "not-selected") {
				errors.push("#restore-file-path");
			}

			if (errors.length)
			{
				for (i in errors)
					$(errors[i]).addClass('error');
				
				$('#restore-backup-form #message td').html('Unacceptable data entered, please specify valid values.');
				$('#restore-backup-form #message').attr('class', 'error');
				return false;
			}

			$('#restore-backup-form #message td').html('Applying changes...');
			$('#restore-backup-form #message').attr('class', 'progress');
			$('#restore-backup-form input').blur();
		},
		success: function(response) {
			$('#restore-backup-form #message td').text(response.message);
			$('#restore-backup-form #message').attr('class', response.status ? 'ok' : 'error');
			if (response.status && goforward) {
				setTimeout(function() {
					window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
				}, 1000);
			}
		}
	});
	$('#next').click(function(){
		goforward = true;
	});
	$("#restore-file-path").change(function() { $(this).removeClass("error"); });
	helper.helptexts["backup-list"] = "The backup file to restore from";
	helper.helptexts["restore-files-only"] = "restore files only. Do not execute any post-restore actions, such as restoring DB from dump";
});
</script>

<div id="content">
<?php if ($disabled) { ?>
	<h1>Restore Backup</h1>
	<p>Restores system from backups prepared by <a href="/op5config/backup">Backup</a> and <a href="/op5config/backupnow" >Backup now</a> utility.</p>
	<p><h1><?php echo $message; ?></h1></p>
<?php } else { ?>
	<form method="POST" action="/op5config/restore/restore" id="restore-backup-form" onsubmit="return false;">
		<h1>Restore Backup</h1>
		<p>Restores system from backups prepared by <a href="/op5config/backup">Backup</a> and <a href="/op5config/backupnow" >Backup now</a> utility.</p>
		<table>
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tbody>
				<tr id="message">
					<td colspan="2">&nbsp;</td>
				</tr>
				<tr>
					<td><a href="#" onclick="help('backup-list')">[?]</a> <label for="backup-list">Select backup file</label></td>
					<td>
						<select name="restore-file-path" id="restore-file-path" class="restore-file-path">
							<option value="not-selected">not selected</option>
							<?php if ($backup_files && !empty($backup_files)) { foreach($backup_files as $file) {?>
							<option value="<?php print $file ?>"><?php print $file ?></option>
							<?php } } ?>
						</select>
					</td>
				</tr>
				<tr>
					<td><a href="#" onclick="help('restore-files-only')">[?]</a> <label for="restore-files-only">Restore files only</label></td>
					<td><input type="checkbox" id="restore-files-only" name="restore-files-only" class="restore-files-only" /></td>
				</tr>
				<tr class="dotted-top">
					<td>&nbsp;</td>
					<td><input type="submit" value="Restore" /></td>
				</tr>
			</tbody>
		</table>
	</form>
<?php } ?>
</div>
