<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<?php
function draw_element($key, $value, $escape = false) { if ($escape) { ob_start(); }?>
	<tr class="modem-element dotted-bottom" id="<?php print $key ?>">
		<td>&nbsp;</td>
		<td>
			<span class="gsm-description"><?php print "$key ({$value['device']}): pincode - {$value['pincode']}, modem - {$value['modem']}, baudrate - {$value['baudrate']}" ?></span>
			<a href="#" style="margin-left: 10px" class="edit-modem-element">edit</a>
			<a href="#" style="margin-left: 10px" class="remove-modem-element">remove</a>
		</td>
	</tr>
	<tr class="modem-param <?php print $key ?>" style="display: none;">
		<td>&nbsp;</td>
		<td><b><?php print $key ?></b></td>
	</tr>
	<tr class="modem-param <?php print $key ?>" style="display: none;">
		<td><a href="#" onclick="help('pin')">[?]</a> <label for="<?php print $key ?>[pincode]">PIN code</label></td>
		<td>
			<input type="text" name="<?php print $key ?>[pincode]" value="<?php echo $value['pincode']; ?>" id="<?php print $key ?>[pincode]" tabindex="1" class="normal optional" maxlength="4" />
			<small>optional</small>
		</td>
	</tr>
	<tr class="modem-param <?php print $key ?>" style="display: none;">
		<td><a href="#" onclick="help('device')">[?]</a> <label for="<?php print $key ?>[device]">Device</label></td>
		<td>
			<input type="text" name="<?php print $key ?>[device]" value="<?php echo $value['device']; ?>" id="<?php print $key ?>[device]" tabindex="1" class="normal" />
		</td>
	</tr>
	<tr class="modem-param <?php print $key ?>" style="display: none;">
		<td><a href="#" onclick="help('modem_type')">[?]</a> <label for="<?php print $key ?>[modem]">Modem type</label></td>
		<td>
			<select name="<?php print $key ?>[modem]" tabindex="2" id="<?php print $key ?>[modem]" class="gsm-select-modem" data-gsm="<?php print $key ?>">
				<option<?php if ($value['modem'] == 'MC35i') echo ' selected="selected"'; ?> value="MC35i">MC35i</option>
				<option<?php if ($value['modem'] == 'TC65') echo ' selected="selected"'; ?> value="TC65">TC65</option>
				<option<?php if ($value['modem'] == 'other') echo ' selected="selected"'; ?> value="other">other</option>
			</select>
		</td>
	</tr>
	<tr class="modem-param <?php print $key ?>" style="display: none;">
		<td><a href="#" onclick="help('baudrate')">[?]</a> <label for="<?php print $key ?>[baudrate]">Baud rate</label></td>
		<td>
			<input type="text" name="<?php print $key ?>[baudrate]" value="<?php echo $value['baudrate']; ?>" id="<?php print $key ?>[baudrate]" tabindex="3" class="baudrate normal<?php
				if ($value['modem'] != 'other') echo ' disabled" disabled="disabled'; ?> " maxlength="6" />
			<input type="hidden"  id="<?php print $key ?>[baudrate2]" value="<?php echo $value['baudrate']; ?>" />
		</td>
	</tr>
	<tr class="modem-param <?php print $key ?> dotted-bottom" style="display: none;">
		<td>&nbsp;</td>
		<td><input type="button" value="Save" data-gsm="<?php print $key ?>" class="modem-save"/><input type="button" value="Cancel" data-gsm="<?php print $key ?>" class="modem-cancel grey"/></td>
	</tr>
<?php if ($escape) { print  preg_replace(array('/\s{2,}/', '/[\t\n]/'), ' ', trim(addslashes(ob_get_clean()))); }} ?>

<script type="text/javascript">
var rxPINCode = /^[0-9]{1,4}$/;
var rxBaudRate = /^2400|4800|9600|19200|38400|57600|115200$/;
var rxPhoneNumber = /^[+]|[0-9]{8,12}$/;
var rxEmpty = /(?:)/;
var rxModem = /^MC35i|TC65|other$/;
var tests = {
	"pincode": rxPINCode,
	"baudrate": rxBaudRate,
	"device": rxEmpty,
	"modem": rxModem
}
<?php
$default_vals = array(
	'pincode' => '',
	'device' => '/dev/null',
	'modem' => 'MC35i',
	'baudrate' => '38400'
);
print "var element_template = \""; draw_element('%%KEY%%', $default_vals, true); print "\";";
print ("var default_vals = " . Json::encode($default_vals));
?>

var goforward = false;
var current_gsm_settings = <?php print Json::encode($data); ?>

$(document).ready(function(){
	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
	$('#my_form').ajaxForm({
		dataType: 'json',
			beforeSubmit: function(){
			$('#message td').html('Starting update...');
			$('#message').attr('class', 'progress');
		},
		success: function(response){
			$('#message td').text(response.message);
			$('#message').attr('class', response.status ? 'ok' : 'error');
			if (response.status && goforward)
				setTimeout(function(){
					window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
				}, 1000);
		}
	});
	$('#next').click(function(){
		goforward = true;
	});
	$('#skip').click(function(){
		// why on earth this does not work?
		// $('#left-menu a.selected').parent().next().find('a').trigger('click');
		window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
		return false;
	});
	$('#test').click(function(){
		if (!rxPhoneNumber.test($('#phone').val()))
		{
			$('#phone').addClass('error');			
			$('#message td').html('Unacceptable data entered, please enter valid values.');
			$('#message').attr('class', 'error');
			return false;
		}

		$.getJSON('/op5config/sms/test', {"phone":$('#phone').val()},
			function(data, textStatus)
		{
			$('#message td').text(data.message);
			$('#message').attr('class', data.status ? 'ok' : 'error');
		});
		return false;
	});
	$('#my_form input, #my_form select').focus(function(){
		$('#message td').html('&nbsp;');
		$('#message').removeAttr('class');
		$(this).removeClass('error');
	});

	var table;

	table = $("#content>table");

	$(".edit-modem-element", table).live("click", function() {
		$("tr.modem-element", table).show();
		var info_elem = $(this).parents("tr.modem-element").hide();
		var name = info_elem.attr("id");
		$("tr.modem-param", table).hide();
		$("tr."+name, table).show();
	});

	$(".remove-modem-element", table).live("click", function() {
		var parent = $(this).parents("tr");
		var id = parent.attr("id");
		delete(current_gsm_settings[id]);
		parent.remove();
		$("tr.modem-param."+id, table).remove();
	});

	update_gsm_element = function(name) {
		if (typeof(current_gsm_settings[name]) === "undefined") { 
			return;
		}
		var data = current_gsm_settings[name];
		$("#"+name+" .gsm-description").text(name + " ("+data.device+"): pincode - " + data.pincode + ", modem - " + data.modem + ", baudrate - " + data.baudrate);
		$.each(data, function(k, v) {
			$("tr."+name+" [name=\""+name+"["+ k +"]"+"\"]").val(v);
		});

	};

	$(".modem-cancel", table).live("click", function() {
		var name = $(this).attr("data-gsm");
		update_gsm_element(name);
		$("tr.modem-param", table).hide();
		$("tr#"+name, table).show();
	});

	$(".modem-save", table).live("click", function () {
		var name = $(this).attr("data-gsm");
		var data = current_gsm_settings[name];
		var with_errors = false;
		var new_values = {};
		$.each(data, function(k, v) {
			var tested_element = $("tr."+name+" [name=\""+name+"["+ k +"]"+"\"]", table);
			var new_val = tested_element.val();
			if (!tests[k].test(new_val) && !(tested_element.hasClass("optional") && (new_val.length == 0))) {
				with_errors = true;
				tested_element.addClass("error");
			} else {
				new_values[k] = vv = $("tr."+name+" [name=\""+name+"["+ k +"]"+"\"]", table).val();
			}
		});
		if (with_errors) {
			return;
		}
		current_gsm_settings[name] = new_values;
		update_gsm_element(name);
		$("tr.modem-param", table).hide();
		$("tr#"+name, table).show();
	});
	$("tr.modem-param", table).live("change", function() {
		$(this).removeClass("error");
	});
	var baud_map = {
		"MC35i": 38400,
		"TC65": 115200,
		"other": ""
	};
	$('.gsm-select-modem').live("change", function(){
		var val = $(this).val();
		var name = $(this).attr("data-gsm");
		var baudr_elem = $("tr.modem-param."+name+" .baudrate", table);
		if (val !== "other") {
			baudr_elem.attr('disabled', 'disabled').addClass('disabled').val(baud_map[val]);
		} else {
			baudr_elem.removeAttr('disabled').removeClass('disabled');
		}
		baudr_elem.val(baud_map[val]);
	});

	var getNewGSMIndex = function() {
		var n = 1;
		$.each(current_gsm_settings, function(k, v) {
			var cv = parseInt(k.substr(3)) || 0;
			if (n < cv) {
				n = cv;
			}
		});
		return n + 1;
	}
	var rxTemplate = /%%KEY%%/g;
	$("#add-new-device", table).bind("click", function() {
		var new_key = "GSM" + getNewGSMIndex();
		current_gsm_settings[new_key] = $.extend(true, {}, default_vals);
		$(this).parents("tr").before($(element_template.replace(rxTemplate, new_key)));
		return false;
	});
});
</script>
<form method="post" id="my_form" action="/op5config/sms/save">
	<div id="content">
		<h1>SMS Settings</h1>
		<p>This configures the smsd program that sends SMS messages. This is only needed if
		your system is equipped with a GSM/GPRS modem.</p>
		<p><strong>Note:</strong> If you don't want to edit this make sure to disable the
		PINcode control on your SIM card.</p>
		<!--<p><a href="#" class="reset">Reset to factory settings</a></p>-->
		<table summary="Edit SMS settings">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="2">&nbsp;</td>
			</tr>
			<?php foreach($data as $key => $value) { draw_element($key, $value); } ?>
			<tr>
				<td>&nbsp;</td>
				<td align="right"><a href="#" id="add-new-device">Add new device</a></td>
			</tr>
			<tr class="button">
				<td>&nbsp;</td>
				<td><input type="submit" value="Apply" tabindex="4" />
				<input type="submit" id="next" value="Apply &amp; continue" class="grey" tabindex="5" />
					<input type="reset" id="skip" value="Skip &amp; continue" class="grey" tabindex="6" /></td>
			</tr>
			<tr class="button dotted-top">
				<td><a href="#" onclick="help('test_sms')">[?]</a> <label for="phone">Phone number</label></td>
				<td><input type="text" name="phone" value="" id="phone" class="normal" tabindex="7" />
				<input type="submit" name="test" value="Send test message" id="test" tabindex="8" /></td>
			</tr>
		</table>
	</div>
</form>
