<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
var rxHostName = /^(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)*[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/;
var zones = <?php echo $zones; ?>;
var current_zone = '<?php echo $current_zone; ?>';
var goforward = false;

$(document).ready(function(){
	for (area in zones) {
		var label = area;
		if(label === "") {
			label = 'General';
		}
		$('#continent').append('<option value="' + area + '">' + label + '</option>');
	}

	$('#continent').change(function(){
		$('#city').empty();
		for (zone in zones[$(this).val()])
			$('#city').append('<option value="' + zones[$(this).val()][zone] + '">' + zones[$(this).val()][zone] + '</option>');
	});

	$('#continent').val(current_zone.slice(0, current_zone.indexOf('/')));
	$('#continent').change();
	$('#city').val(current_zone.slice(current_zone.indexOf('/') + 1));

	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);

	$('#my_form').ajaxForm({
		dataType: 'json',
		beforeSubmit: function(){
			$('#message td').html('Applying changes...');
			$('#message').attr('class', 'progress');
			$('#my_form input, #my_form select').blur();
		},
		success: function(response){
			$('#message td').text(response.message);
			$('#message').attr('class', response.status ? 'ok' : 'error');
			$('#avail option').removeAttr('selected');
			if (response.status && goforward)
				setTimeout(function(){
					window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
				}, 1000);
		}
	});
	$('#next').click(function(){
		goforward = true;
		$('#avail option').attr('selected', 'selected');
	});
	$('#skip').click(function(){
		// why on earth this does not work?
		// $('#left-menu a.selected').parent().next().find('a').trigger('click');
		window.location.replace($('#left-menu a.selected').parent().next().find('a').attr('href'));
		return false;
	});
	$('#my_form input, #my_form select').focus(function(){
		$('#message td').html('&nbsp;');
		$('#message').removeAttr('class');
		$(this).removeClass('error');
	});

	$('#add').click(function(){
		if (!rxHostName.test($('#ntp').val()))
		{
			$('#ntp').addClass('error');			
			$('#message td').html('Unacceptable data entered, please enter valid values.');
			$('#message').attr('class', 'error');
			return false;
		}

		$('#avail').append('<option value="' + $('#ntp').val() + '">' + $('#ntp').val() + '</option>');
		return false;
	});
	$('#remove').click(function(){
		$('#avail option:selected').remove();
		return false;
	});

	// THIS IS IMPORTANT!!!
	// otherwise only selected servers will be passed
	$('#save').click(function(){
		$('#avail option').attr('selected', 'selected');
	});
});
</script>
<form method="post" id="my_form" action="/op5config/time/save">
	<div id="content">
		<h1>Time Settings</h1>
		<p>This configures which server that the op5 System shall use as Network Time Server.
		It is possible to add several server entries to get time from several NTP servers.</p>
		<p>If you are unsure about if you have a NTP server to synchronize against you can
		always use pool.ntp.org which is a large pool of, free to use, NTP servers on the
		Internet.</p>

		<!--<p><a href="#" class="reset">Reset to factory settings</a></p>-->
		<table summary="Edit email settings">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td class="top"><a href="#" onclick="help('ntp')">[?]</a> <label for="ntp">NTP server</label></td>
				<td>
					<input type="text" name="ntp" value="" id="ntp" tabindex="1" class="normal" />
					<input type="button" id="add" name="add" value="Add" tabindex="2" />
					<br /><br />
					<span>Available servers:</span><br />
					<select name="avail[]" id="avail" multiple="multiple" size="5" tabindex="3" class="multiple">
					<?php foreach ($servers as $server) { ?>
						<option value="<?php echo $server; ?>"><?php echo $server; ?></option>
					<?php } ?>
					</select>
					<input type="button" id="remove" name="remove" value="Remove" tabindex="4" class="remove" />
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('continent')">[?]</a> <label for="continent">Select continent/country</label></td>
				<td>
					<select name="continent" id="continent" tabindex="5">
					</select>
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('city')">[?]</a> <label for="city">Select area</label></td>
				<td>
					<select name="city" id="city" tabindex="6">
					</select>
				</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('utc')">[?]</a> <label for="utc_yes">Hardware clock uses UTC?</label></td>
				<td>
					<input type="radio" name="utc" value="true" id="utc_yes" class="checkbox" tabindex="7"<?php if ($utc) echo ' checked="checked"'; ?> /> <label for="utc_yes">Yes</label>
					<input type="radio" name="utc" value="false" id="utc_no" class="checkbox" tabindex="7"<?php if (!$utc) echo ' checked="checked"'; ?> /> <label for="utc_no">No</label>
				</td>
			</tr>
			<tr class="button dotted-top">
				<td>&nbsp;</td>
				<td>
				<input type="submit" id="save" value="Apply" tabindex="8" />
				<input type="submit" id="next" value="Apply &amp; continue" class="grey" tabindex="9" />
				<input type="reset" id="skip" value="Skip &amp; continue" class="grey" tabindex="10" /></td>
			</tr>
		</table>
	</div>
</form>
