<?php defined('SYSPATH') OR die('No direct access allowed.'); ?>

<script type="text/javascript">
showUpdateProcessFlag=false;
$(document).ready(function(){
	showUpdateProcessFlag=false;
	$.blockUI.defaults.message = null;
	$.blockUI.defaults.overlayCSS = {cursor: 'wait'};
	$(document).ajaxStart($.blockUI).ajaxStop($.unblockUI);
	$('#my_form').ajaxForm({
		dataType: 'json',
		beforeSubmit: function(){
			$('#message td').html('Starting update...');
			$('#message').attr('class', 'progress');
			$('#my_form input, #my_form select').blur();
		},
		success: function(response){
			$('#message td').text(response.message);
			$('#message').attr('class', response.status ? 'ok' : 'error');
			if(showUpdateProcessFlag)
			{
				$('#navbar p:last').html('<img src="/portal/images/icon-info.png" alt="info" /> System update is in progress!');
				if(response.status ) showUpdateProcess();
			}
		}
	});
	$('#my_form input, #my_form select').focus(function(){
		$('#message td').html('&nbsp;');
		$('#message').removeAttr('class');
	});
	$('#install_all').click(function(){
		$('#packages option').attr('selected', 'selected');
		showUpdateProcessFlag=true;
		$('#my_form').submit();
	});
	
	$('#install_selected').click(function(){
		if($('#packages option:selected').length == 0){
		    return false;
		};
		showUpdateProcessFlag=true;
		$('#my_form').submit();
	});
	
	        
	
});

function showUpdateProcess(){
    $('#my_form table').hide();
    $('#statusContainer').show();
    var statusTA = $('#statusTextArea');
    statusTA.show();
    var startByte = 0;
    var interval = setInterval(function(){
	$.ajax({
    	url: '/op5config/update/status',
	    dataType: 'json',
	    data: {'startByte':startByte},
	    success: function(response) {
		console.log(response);
	    if(response.status){
		var text = statusTA.val()+response.message;
		startByte = text.length;
		statusTA.val(text);
		statusTA.scrollTop(statusTA[0].scrollHeight - statusTA.height());
	    }else{
			clearInterval(interval);
			$('#navbar p:last').html('');
	    }
         }
	});
    },
    1000
    );
    showUpdateProcessFlag=false;
    
}
</script>
<form method="post" id="my_form" action="/op5config/update/update">
	<div id="content">
		<h1>Update System</h1>
		<p>Check for available updates for your op5 installation.<br />
		For manual search for updates, please visit <a href="https://www.op5.com/support" class="about">www.op5.com/support</a>
		</p>
		<div id="statusContainer">
			<textarea id="statusTextArea" readonly="readonly"></textarea>
			<div><input type="button" value="Back" onclick="window.location.reload();" /></div>
		</div>
		<table summary="Edit update settings">
			<colgroup>
				<col class="td_column_name" />
				<col class="auto" />
			</colgroup>
			<tr id="message">
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td><a href="#" onclick="help('autoupdates')">[?]</a> <label for="disable">Automatic nightly updates</label></td>
				<td>
					<input type="radio" name="autoupdate" value="on" class="checkbox" id="enable"<?php if ($autoupdate) echo ' checked="checked"'; ?> tabindex="1" /><label for="enable">Enabled</label>
					<input type="radio" name="autoupdate" value="off" class="checkbox" id="disable"<?php if (!$autoupdate) echo ' checked="checked"'; ?> tabindex="1" /><label for="disable">Disabled</label>
				</td>
			</tr>
			<tr class="button dotted-top">
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="save" value="Save" tabindex="2" /><br /><br />
				</td>
			</tr>
			<?php if ($packages === false) { ?>
			<tr  class="dotted-top">
				<td colspan="2">Another yum process is currently running, no information about updates is available.</td>
			</tr>
			<?php } else { ?>
			<tr class="dotted-top">
				<td><a href="#" onclick="help('updates')">[?]</a> <label for="packages[]">Available updates</label></td>
				<td>
					<select name="packages[]" id="packages" multiple="multiple" size="25" class="multiple-large" tabindex="3">
						<?php foreach ($packages as $package) { ?>
							<option value="<?php echo $package; ?>"><?php echo $package; ?></option>
						<?php } ?>
					</select>
				</td>
			</tr>
			<tr class="button dotted-top">
				<td>&nbsp;</td>
				<td><input type="button" id="install_selected"  value=" Install selected" tabindex="4" />
					<input type="button" id="install_all" value="Install all" tabindex="5" /></td>
			</tr>
			<?php } ?>
		</table>
	</div>
</form>
